# =============================================================
#                CodeTyphon Studio
#      Copyright (c) PilotLogic Software House.
#               All rights reserved.
# =============================================================

hassys32sub() 
{
vsysfpc32sub=0
vsyslaz32sub=0

if [ -f /etc/SuSE-release ] ;
then   
  vsysfpc32sub=1
  vsyslaz32sub=0
fi

if [ $(uname) = "SunOS" ] ; 
then  
  vsysfpc32sub=1
  vsyslaz32sub=1
fi

}

setdummy32()
{

if [ $(uname) = "SunOS" ] ; 
then  
vosname=solaris  
vname=solaris32
vsrcbindir=i386-solaris
vmake=gmake 
else
vosname=linux
vname=linux32
vsrcbindir=i386-linux
vmake=make
fi

vsysfpc32sub=0
vsyslaz32sub=0

vbits=32
vfpcexec=ppc386

vcodetyphon=/usr/lib/codetyphon
vfpcver=2.7.1
# vfpccfgdir=/etc
vfpclibdir=/usr/lib/codetyphon/fpc
vfpcbindir=/usr/lib/codetyphon/fpc/bin
vfpcsrcdir=/usr/lib/codetyphon/fpcsrc
vfpcrundir=/usr/bin

vlazlibdir=/usr/lib/codetyphon
vlazrundir=/usr/bin  

vappdskdir=/usr/share/applications
vappxmldir=/usr/share/mime/packages
vapppngdir=/usr/share/pixmaps

vlazsetdir=~/.lazarus$vbits
vfpcexedir=$vfpcbindir/$vsrcbindir
vfpccfgdir=$vfpcexedir
}

getvalues()
{
setdummy32

vosrealname=$(uname) 
      
case $vosrealname in
  Linux)
     vosname=linux  
     if [ ! $(uname -m) = "x86_64" ] ; 
     then 
       vname=linux32          
     else      
       vname=linux64
       vbits=64
       vsrcbindir=x86_64-linux
       vfpcexec=ppcx64
       hassys32sub
     fi
   ;;
  FreeBSD) 
      vosname=freebsd  
      vmake=gmake
      vappdskdir=/usr/local/share/applications
      vappxmldir=/usr/local/share/mime/packages
      vapppngdir=/usr/local/share/pixmaps
      if [ ! $(uname -m) = "amd64" ] ; 
      then 
         vname=freebsd32
         vsrcbindir=i386-freebsd
      else
         vname=freebsd64
         vbits=64
         vsrcbindir=x86_64-freebsd
         vfpcexec=ppcx64  
      fi
   ;;
  OpenBSD) 
      vosname=openbsd  
      vmake=gmake
      vappdskdir=/usr/local/share/applications
      vappxmldir=/usr/local/share/mime/packages
      vapppngdir=/usr/local/share/pixmaps
      if [ ! $(uname -m) = "amd64" ] ; 
      then 
         vname=openbsd32
         vsrcbindir=i386-openbsd
      else
         vname=openbsd64
         vbits=64
         vsrcbindir=x86_64-openbsd
         vfpcexec=ppcx64  
      fi
   ;;
  NetBSD) 
      vosname=netbsd  
      vmake=gmake
      vappdskdir=/usr/local/share/applications
      vappxmldir=/usr/local/share/mime/packages
      vapppngdir=/usr/local/share/pixmaps
      if [ ! $(uname -m) = "amd64" ] ; 
      then 
         vname=netbsd32
         vsrcbindir=i386-netbsd
      else
         vname=netbsd64
         vbits=64
         vsrcbindir=x86_64-netbsd
         vfpcexec=ppcx64  
      fi
   ;;
  SunOS)
      vosname=solaris  
      vmake=gmake  

      if [ ! $(isainfo -b) = "64" ] ; 
      then 
         vname=solaris32
         vsrcbindir=i386-solaris
      else
         vname=solaris64
         vbits=64
         vsrcbindir=x86_64-solaris
         vfpcexec=ppcx64 
         hassys32sub
      fi
   ;;
esac

vlazsetdir=~/.lazarus$vbits
vfpcexedir=$vfpcbindir/$vsrcbindir
vfpccfgdir=$vfpcexedir
}

# ===============================================
# ===============================================

# ****************Linux*********************

findlinux()
{

#------------ 100 Ubuntu----------------------------
 if [ -f /etc/lsb-release  ] && [ ! -f /etc/chakra-release ] ; then
   OS_VerNum=100
   OS_VerStr="Ubuntu Linux" 
    
#------------ 200 SuSE------------------------------            
 elif [ -f /etc/SuSE-release ] ; then
   OS_VerNum=200
   OS_VerStr="SuSE Linux"           
 elif [ -f /etc/novell-release ] ; then
   OS_VerNum=200
   OS_VerStr="SuSE Linux"            
 elif [ -f /etc/sles-release ] ; then
   OS_VerNum=200
   OS_VerStr="SUSE Linux ES9"           
 elif [ -f /etc/nld-release ] ; then
   OS_VerNum=200
   OS_VerStr="Novell Linux Desktop"          
 elif [ -f /etc/UnitedLinux-release ] ; then
   OS_VerNum=200
   OS_VerStr="UnitedLinux"                          
   
#------------ 300 Debian ---------------------------             
 elif [ -f /etc/debian_version ] ; then
   OS_VerNum=300
   OS_VerStr="Debian Linux"               
 elif [ -f /etc/knoppix_version ] ; then
   OS_VerNum=300
   OS_VerStr="Knoppix Linux"  
       
#------------ 400 CentOS --------------------------              
 elif [ -f /etc/centos-release ] ; then
   OS_VerNum=400
   OS_VerStr="CentOS Linux"  
   
#------------ 500 Fedora -------------------------                         
 elif [ -f /etc/fedora-release ] ; then
   OS_VerNum=500
   OS_VerStr="Fedora Linux"                        
 elif [ -f /etc/aurox-release ] ; then
   OS_VerNum=500
   OS_VerStr="Aurox Linux"                        
 elif [ -f /etc/blackcat-release ] ; then
   OS_VerNum=500
   OS_VerStr="BlackCat Linux"                        
 elif [ -f /etc/yellowdog-release ] ; then
   OS_VerNum=500
   OS_VerStr="Yellow Dog Linux"                        
 elif [ -f /etc/tinysofa-release ] ; then
   OS_VerNum=500
   OS_VerStr="Tiny Sofa Linux"                       
 elif [ -f /etc/e-smith-release ] ; then
   OS_VerNum=500
   OS_VerStr="SME Server (E-Smith) Linux"  

#------------ 600 RedHat -------------------------               
 elif [ -f /etc/redhat-release ] ; then
   OS_VerNum=600
   OS_VerStr="Red Hat Linux"               
 elif [ -f /etc/immunix-release ] ; then
   OS_VerNum=600
   OS_VerStr="Immunix Linux"  

#------------ 700 Gentoo ---------------------------            
 elif [ -f /etc/gentoo-release ] ; then
   OS_VerNum=700
   OS_VerStr="Gentoo Linux"

#------------ 740 ChakraLinux ------------------------            
 elif [ -f /etc/chakra-release ] ; then
   OS_VerNum=740
   OS_VerStr="Chakra Linux"
   OS_QtOnly="Yes"
   
#------------ 750 ArchLinux ------------------------            
 elif [ -f /etc/arch-release ] ; then
   OS_VerNum=750
   OS_VerStr="Arch Linux"
   
#------------ 800 Slackware -----------------------               
 elif [ -f /etc/slackware-version ] ; then
   OS_VerNum=800
   OS_VerStr="Slackware Linux" 
 fi 

}

# ****************FreeBSD*********************

findfreebsd()
{
   OS_VerNum=2000
   OS_VerStr="FreeBSD"
} 

# ****************OpenBSD*********************

findopenbsd()
{
   OS_VerNum=3000
   OS_VerStr="OpenBSD"
} 

# ****************NetBSD*********************

findnetbsd()
{
   OS_VerNum=4000
   OS_VerStr="NetBSD"
}

# ****************Solaris*********************

findsolaris()
{
   OS_VerNum=5000
   OS_VerStr="Solaris"
} 

# *****************Do_The_Job******************
getdistribution()
{
OS_name=$(uname)
OS_VerNum=1
OS_VerStr="Sorry, Unknown OS ???"  

case $OS_name in
Linux)
  findlinux
;;
FreeBSD)
  findfreebsd
;;
OpenBSD)
  findopenbsd
;;
NetBSD)
  findnetbsd
;;
SunOS)
  findsolaris
;;
esac

}



